FIX::ThreadedSocketInitiator Class Reference
User

Threaded Socket implementation of Initiator. More...

`#include <ThreadedSocketInitiator.h>`

Inheritance diagram for FIX::ThreadedSocketInitiator:
[legend]
Collaboration diagram for FIX::ThreadedSocketInitiator:
[legend]

## Public Member Functions

| ThreadedSocketInitiator (Application &, MessageStoreFactory &, const SessionSettings &) throw ( ConfigError )
| ThreadedSocketInitiator (Application &, MessageStoreFactory &, const SessionSettings &, LogFactory &) throw ( ConfigError )
virtual | ~ThreadedSocketInitiator ()
Public Member Functions inherited from FIX::Initiator
| Initiator (Application &, MessageStoreFactory &, const SessionSettings &) throw ( ConfigError )
| Initiator (Application &, MessageStoreFactory &, const SessionSettings &, LogFactory &) throw ( ConfigError )
virtual | ~Initiator ()
void | start () throw ( ConfigError, RuntimeError )
| Start initiator. More...
void | block () throw ( ConfigError, RuntimeError )
| Block on the initiator. More...
bool | poll (double timeout=0.0) throw ( ConfigError, RuntimeError )
| Poll the initiator. More...
void | stop (bool force=false)
| Stop initiator. More...
bool | isLoggedOn ()
| Check to see if any sessions are currently logged on. More...
Session * | getSession (const SessionID &sessionID, Responder &)
const std::set< SessionID > & | getSessions () const
Session * | getSession (const SessionID &sessionID) const
const Dictionary *const | getSessionSettings (const SessionID &sessionID) const
bool | has (const SessionID &id)
bool | isStopped ()
Application & | getApplication ()
MessageStoreFactory & | getMessageStoreFactory ()
Log * | getLog ()

## Private Types

typedef std::map< int, thread_id > | SocketToThread
typedef std::map< SessionID, int > | SessionToHostNum
typedef std::pair< ThreadedSocketInitiator *, ThreadedSocketConnection *> | ThreadPair

## Private Member Functions

void | onConfigure (const SessionSettings &) throw ( ConfigError )
| Implemented to configure acceptor. More...
void | onInitialize (const SessionSettings &) throw ( RuntimeError )
| Implemented to initialize initiator. More...
void | onStart ()
| Implemented to start connecting to targets. More...
bool | onPoll (double timeout)
| Implemented to connect and poll for events. More...
void | onStop ()
| Implemented to stop a running initiator. More...
void | doConnect (const SessionID &s, const Dictionary &d)
| Implemented to connect a session to its target. More...
void | addThread (int s, thread_id t)
void | removeThread (int s)
void | lock ()
void | getHost (const SessionID &, const Dictionary &, std::string &, short &)

## Static Private Member Functions

static THREAD_PROC | socketThread (void *p)

## Private Attributes

SessionSettings | m_settings
SessionToHostNum | m_sessionToHostNum
time_t | m_lastConnect
int | m_reconnectInterval
bool | m_noDelay
int | m_sendBufSize
int | m_rcvBufSize
SocketToThread | m_threads
Mutex | m_mutex

## Additional Inherited Members

Protected Member Functions inherited from FIX::Initiator
void | setPending (const SessionID &)
void | setConnected (const SessionID &)
void | setDisconnected (const SessionID &)
bool | isPending (const SessionID &)
bool | isConnected (const SessionID &)
bool | isDisconnected (const SessionID &)
void | connect ()

## Detailed Description

Threaded Socket implementation of Initiator.

Definition at line 39 of file ThreadedSocketInitiator.h.

## Member Typedef Documentation

## SessionToHostNum

typedef std::map< SessionID, int > FIX::ThreadedSocketInitiator::SessionToHostNum

private

Definition at line 52 of file ThreadedSocketInitiator.h.

## SocketToThread

typedef std::map< int, thread_id > FIX::ThreadedSocketInitiator::SocketToThread

private

Definition at line 51 of file ThreadedSocketInitiator.h.

## ThreadPair

typedef std::pair< ThreadedSocketInitiator*, ThreadedSocketConnection* > FIX::ThreadedSocketInitiator::ThreadPair

private

Definition at line 53 of file ThreadedSocketInitiator.h.

## Constructor & Destructor Documentation

## ThreadedSocketInitiator() [1/2]

FIX::ThreadedSocketInitiator::ThreadedSocketInitiator | ( | Application & | application,
|  | MessageStoreFactory & | factory,
|  | const SessionSettings & | settings
| ) |  |
throw | ( | ConfigError
| ) |  |

Definition at line 32 of file ThreadedSocketInitiator.cpp.

References FIX::socket_init().

: Initiator( application, factory, settings ),
m_lastConnect( 0 ), m_reconnectInterval( 30 ), m_noDelay( false ),
m_sendBufSize( 0 ), m_rcvBufSize( 0 )
{
socket_init();
}
FIX::socket_init
void socket_init()
Definition: Utility.cpp:81
FIX::ThreadedSocketInitiator::m_lastConnect
time_t m_lastConnect
Definition: ThreadedSocketInitiator.h:73
FIX::ThreadedSocketInitiator::m_noDelay
bool m_noDelay
Definition: ThreadedSocketInitiator.h:75
FIX::Initiator::Initiator
Initiator(Application &, MessageStoreFactory &, const SessionSettings &)
Definition: Initiator.cpp:36
FIX::ThreadedSocketInitiator::m_rcvBufSize
int m_rcvBufSize
Definition: ThreadedSocketInitiator.h:77
FIX::ThreadedSocketInitiator::m_reconnectInterval
int m_reconnectInterval
Definition: ThreadedSocketInitiator.h:74
FIX::ThreadedSocketInitiator::m_sendBufSize
int m_sendBufSize
Definition: ThreadedSocketInitiator.h:76

## ThreadedSocketInitiator() [2/2]

FIX::ThreadedSocketInitiator::ThreadedSocketInitiator | ( | Application & | application,
|  | MessageStoreFactory & | factory,
|  | const SessionSettings & | settings,
|  | LogFactory & | logFactory
| ) |  |
throw | ( | ConfigError
| ) |  |

Definition at line 43 of file ThreadedSocketInitiator.cpp.

References FIX::socket_init().

: Initiator( application, factory, settings, logFactory ),
m_lastConnect( 0 ), m_reconnectInterval( 30 ), m_noDelay( false ),
m_sendBufSize( 0 ), m_rcvBufSize( 0 )
{
socket_init();
}
FIX::socket_init
void socket_init()
Definition: Utility.cpp:81
FIX::ThreadedSocketInitiator::m_lastConnect
time_t m_lastConnect
Definition: ThreadedSocketInitiator.h:73
FIX::ThreadedSocketInitiator::m_noDelay
bool m_noDelay
Definition: ThreadedSocketInitiator.h:75
FIX::Initiator::Initiator
Initiator(Application &, MessageStoreFactory &, const SessionSettings &)
Definition: Initiator.cpp:36
FIX::ThreadedSocketInitiator::m_rcvBufSize
int m_rcvBufSize
Definition: ThreadedSocketInitiator.h:77
FIX::ThreadedSocketInitiator::m_reconnectInterval
int m_reconnectInterval
Definition: ThreadedSocketInitiator.h:74
FIX::ThreadedSocketInitiator::m_sendBufSize
int m_sendBufSize
Definition: ThreadedSocketInitiator.h:76

## ~ThreadedSocketInitiator()

FIX::ThreadedSocketInitiator::~ThreadedSocketInitiator | ( |  | ) |

virtual

Definition at line 55 of file ThreadedSocketInitiator.cpp.

References FIX::socket_term().

{
socket_term();
}
FIX::socket_term
void socket_term()
Definition: Utility.cpp:96

## Member Function Documentation

## addThread()

void FIX::ThreadedSocketInitiator::addThread | ( | int | s,
|  | thread_id | t
| ) |  |

private

Definition at line 181 of file ThreadedSocketInitiator.cpp.

References m_mutex, and m_threads.

Referenced by doConnect().

{
Locker l(m_mutex);
m_threads[ s ] = t;
}
FIX::ThreadedSocketInitiator::m_threads
SocketToThread m_threads
Definition: ThreadedSocketInitiator.h:78
FIX::ThreadedSocketInitiator::m_mutex
Mutex m_mutex
Definition: ThreadedSocketInitiator.h:79

## doConnect()

void FIX::ThreadedSocketInitiator::doConnect | ( | const SessionID & | ,
|  | const Dictionary & |
| ) |  |

private virtual

Implemented to connect a session to its target.

Implements FIX::Initiator.

Definition at line 133 of file ThreadedSocketInitiator.cpp.

References addThread(), FIX::IntConvertor::convert(), FIX::ThreadedSocketConnection::disconnect(), getHost(), FIX::Initiator::getLog(), FIX::Session::getLog(), FIX::Session::isSessionTime(), FIX::Session::lookupSession(), m_mutex, m_noDelay, m_rcvBufSize, m_sendBufSize, FIX::Log::onEvent(), FIX::Initiator::setDisconnected(), FIX::Initiator::setPending(), FIX::socket_createConnector(), FIX::socket_setsockopt(), socketThread(), and FIX::thread_spawn().

{
try
{
Session* session = Session::lookupSession( s );
if( !session->isSessionTime(UtcTimeStamp()) ) return;
Log* log = session->getLog();
std::string address;
short port = 0;
getHost( s, d, address, port );
int socket = socket_createConnector();
if( m_noDelay )
socket_setsockopt( socket, TCP_NODELAY );
if( m_sendBufSize )
socket_setsockopt( socket, SO_SNDBUF, m_sendBufSize );
if( m_rcvBufSize )
socket_setsockopt( socket, SO_RCVBUF, m_rcvBufSize );
setPending( s );
log->onEvent( "Connecting to " + address + " on port " + IntConvertor::convert((unsigned short)port) );
ThreadedSocketConnection* pConnection =
new ThreadedSocketConnection( s, socket, address, port, getLog() );
ThreadPair* pair = new ThreadPair( this, pConnection );
{
Locker l( m_mutex );
thread_id thread;
if ( thread_spawn( &socketThread, pair, thread ) )
{
addThread( socket, thread );
}
else
{
delete pair;
pConnection->disconnect();
delete pConnection;
setDisconnected( s );
}
}
}
catch ( std::exception& ) {}
}
FIX::ThreadedSocketInitiator::getHost
void getHost(const SessionID &, const Dictionary &, std::string &, short &)
Definition: ThreadedSocketInitiator.cpp:238
FIX::Session::lookupSession
static Session * lookupSession(const SessionID &)
Definition: Session.cpp:1403
FIX::ThreadedSocketInitiator::ThreadPair
std::pair< ThreadedSocketInitiator *, ThreadedSocketConnection *> ThreadPair
Definition: ThreadedSocketInitiator.h:53
FIX::ThreadedSocketInitiator::m_noDelay
bool m_noDelay
Definition: ThreadedSocketInitiator.h:75
FIX::socket_createConnector
int socket_createConnector()
Definition: Utility.cpp:126
FIX::thread_spawn
bool thread_spawn(THREAD_START_ROUTINE func, void *var, thread_id &thread)
Definition: Utility.cpp:394
FIX::ThreadedSocketInitiator::m_rcvBufSize
int m_rcvBufSize
Definition: ThreadedSocketInitiator.h:77
FIX::IntConvertor::convert
static std::string convert(signed_int value)
Definition: FieldConvertors.h:154
FIX::ThreadedSocketInitiator::socketThread
static THREAD_PROC socketThread(void *p)
Definition: ThreadedSocketInitiator.cpp:200
FIX::socket_setsockopt
int socket_setsockopt(int s, int opt)
Definition: Utility.cpp:186
FIX::Initiator::getLog
Log * getLog()
Definition: Initiator.h:90
FIX::ThreadedSocketInitiator::addThread
void addThread(int s, thread_id t)
Definition: ThreadedSocketInitiator.cpp:181
FIX::thread_id
pthread_t thread_id
Definition: Utility.h:164
FIX::TYPE::UtcTimeStamp
Definition: FieldTypes.h:674
FIX::ThreadedSocketInitiator::m_sendBufSize
int m_sendBufSize
Definition: ThreadedSocketInitiator.h:76
FIX::Initiator::setPending
void setPending(const SessionID &)
Definition: Initiator.cpp:145
FIX::ThreadedSocketInitiator::m_mutex
Mutex m_mutex
Definition: ThreadedSocketInitiator.h:79
FIX::Initiator::setDisconnected
void setDisconnected(const SessionID &)
Definition: Initiator.cpp:163

## getHost()

void FIX::ThreadedSocketInitiator::getHost | ( | const SessionID & | s,
|  | const Dictionary & | d,
|  | std::string & | address,
|  | short & | port
| ) |  |

private

Definition at line 238 of file ThreadedSocketInitiator.cpp.

References FIX::Dictionary::getInt(), FIX::Dictionary::getString(), FIX::Dictionary::has(), m_sessionToHostNum, FIX::SOCKET_CONNECT_HOST, and FIX::SOCKET_CONNECT_PORT.

Referenced by doConnect(), and lock().

{
int num = 0;
SessionToHostNum::iterator i = m_sessionToHostNum.find( s );
if ( i != m_sessionToHostNum.end() ) num = i->second;
std::stringstream hostStream;
hostStream << SOCKET_CONNECT_HOST << num;
std::string hostString = hostStream.str();
std::stringstream portStream;
portStream << SOCKET_CONNECT_PORT << num;
std::string portString = portStream.str();
if( d.has(hostString) && d.has(portString) )
{
address = d.getString( hostString );
port = ( short ) d.getInt( portString );
}
else
{
num = 0;
address = d.getString( SOCKET_CONNECT_HOST );
port = ( short ) d.getInt( SOCKET_CONNECT_PORT );
}
m_sessionToHostNum[ s ] = ++num;
}
FIX::SOCKET_CONNECT_HOST
const char SOCKET_CONNECT_HOST[]
Definition: SessionSettings.h:64
FIX::SOCKET_CONNECT_PORT
const char SOCKET_CONNECT_PORT[]
Definition: SessionSettings.h:65
FIX::ThreadedSocketInitiator::m_sessionToHostNum
SessionToHostNum m_sessionToHostNum
Definition: ThreadedSocketInitiator.h:72

## lock()

void FIX::ThreadedSocketInitiator::lock | ( |  | ) |

inline private

Definition at line 66 of file ThreadedSocketInitiator.h.

References getHost(), m_mutex, socketThread(), and THREAD_PROC.

{ Locker l(m_mutex); }
FIX::ThreadedSocketInitiator::m_mutex
Mutex m_mutex
Definition: ThreadedSocketInitiator.h:79

## onConfigure()

void FIX::ThreadedSocketInitiator::onConfigure | ( | const SessionSettings & |  | ) |
throw | ( | ConfigError
| ) |  |

private virtual

Implemented to configure acceptor.

Reimplemented from FIX::Initiator.

Definition at line 60 of file ThreadedSocketInitiator.cpp.

References FIX::Dictionary::getBool(), FIX::Dictionary::getInt(), FIX::Dictionary::has(), m_noDelay, m_rcvBufSize, m_reconnectInterval, m_sendBufSize, FIX::RECONNECT_INTERVAL, FIX::SOCKET_NODELAY, FIX::SOCKET_RECEIVE_BUFFER_SIZE, and FIX::SOCKET_SEND_BUFFER_SIZE.

{
const Dictionary& dict = s.get();
if( dict.has( RECONNECT_INTERVAL ) )
m_reconnectInterval = dict.getInt( RECONNECT_INTERVAL );
if( dict.has( SOCKET_NODELAY ) )
m_noDelay = dict.getBool( SOCKET_NODELAY );
if( dict.has( SOCKET_SEND_BUFFER_SIZE ) )
m_sendBufSize = dict.getInt( SOCKET_SEND_BUFFER_SIZE );
if( dict.has( SOCKET_RECEIVE_BUFFER_SIZE ) )
m_rcvBufSize = dict.getInt( SOCKET_RECEIVE_BUFFER_SIZE );
}
FIX::RECONNECT_INTERVAL
const char RECONNECT_INTERVAL[]
Definition: SessionSettings.h:69
FIX::ThreadedSocketInitiator::m_noDelay
bool m_noDelay
Definition: ThreadedSocketInitiator.h:75
FIX::SOCKET_NODELAY
const char SOCKET_NODELAY[]
Definition: SessionSettings.h:66
FIX::SOCKET_SEND_BUFFER_SIZE
const char SOCKET_SEND_BUFFER_SIZE[]
Definition: SessionSettings.h:67
FIX::ThreadedSocketInitiator::m_rcvBufSize
int m_rcvBufSize
Definition: ThreadedSocketInitiator.h:77
FIX::SOCKET_RECEIVE_BUFFER_SIZE
const char SOCKET_RECEIVE_BUFFER_SIZE[]
Definition: SessionSettings.h:68
FIX::ThreadedSocketInitiator::m_reconnectInterval
int m_reconnectInterval
Definition: ThreadedSocketInitiator.h:74
FIX::ThreadedSocketInitiator::m_sendBufSize
int m_sendBufSize
Definition: ThreadedSocketInitiator.h:76

## onInitialize()

void FIX::ThreadedSocketInitiator::onInitialize | ( | const SessionSettings & |  | ) |
throw | ( | RuntimeError
| ) |  |

private virtual

Implemented to initialize initiator.

Reimplemented from FIX::Initiator.

Definition at line 75 of file ThreadedSocketInitiator.cpp.

{
}

## onPoll()

bool FIX::ThreadedSocketInitiator::onPoll | ( | double | timeout | ) |

private virtual

Implemented to connect and poll for events.

Implements FIX::Initiator.

Definition at line 98 of file ThreadedSocketInitiator.cpp.

{
return false;
}

## onStart()

void FIX::ThreadedSocketInitiator::onStart | ( |  | ) |

private virtual

Implemented to start connecting to targets.

Implements FIX::Initiator.

Definition at line 80 of file ThreadedSocketInitiator.cpp.

References FIX::Initiator::connect(), FIX::Initiator::isStopped(), m_lastConnect, m_mutex, m_reconnectInterval, and FIX::process_sleep().

{
while ( !isStopped() )
{
time_t now;
::time( &now );
if ( (now - m_lastConnect) >= m_reconnectInterval )
{
Locker l( m_mutex );
connect();
m_lastConnect = now;
}
process_sleep( 1 );
}
}
FIX::ThreadedSocketInitiator::m_lastConnect
time_t m_lastConnect
Definition: ThreadedSocketInitiator.h:73
FIX::Initiator::connect
void connect()
Definition: Initiator.cpp:131
FIX::process_sleep
void process_sleep(double s)
Definition: Utility.cpp:444
FIX::ThreadedSocketInitiator::m_reconnectInterval
int m_reconnectInterval
Definition: ThreadedSocketInitiator.h:74
FIX::Initiator::isStopped
bool isStopped()
Definition: Initiator.h:83
FIX::ThreadedSocketInitiator::m_mutex
Mutex m_mutex
Definition: ThreadedSocketInitiator.h:79

## onStop()

void FIX::ThreadedSocketInitiator::onStop | ( |  | ) |

private virtual

Implemented to stop a running initiator.

Implements FIX::Initiator.

Definition at line 103 of file ThreadedSocketInitiator.cpp.

References FIX::Initiator::isLoggedOn(), m_mutex, m_threads, FIX::socket_close(), FIX::Initiator::start(), and FIX::thread_join().

{
SocketToThread threads;
SocketToThread::iterator i;
{
Locker l(m_mutex);
time_t start = 0;
time_t now = 0;
::time( &start );
while ( isLoggedOn() )
{
if( ::time(&now) -5 >= start )
break;
}
threads = m_threads;
m_threads.clear();
}
for ( i = threads.begin(); i != threads.end(); ++i )
socket_close( i->first );
for ( i = threads.begin(); i != threads.end(); ++i )
thread_join( i->second );
threads.clear();
}
FIX::thread_join
void thread_join(thread_id thread)
Definition: Utility.cpp:415
FIX::ThreadedSocketInitiator::SocketToThread
std::map< int, thread_id > SocketToThread
Definition: ThreadedSocketInitiator.h:51
FIX::Initiator::start
void start()
Start initiator.
Definition: Initiator.cpp:190
FIX::ThreadedSocketInitiator::m_threads
SocketToThread m_threads
Definition: ThreadedSocketInitiator.h:78
FIX::Initiator::isLoggedOn
bool isLoggedOn()
Check to see if any sessions are currently logged on.
Definition: Initiator.cpp:269
FIX::socket_close
void socket_close(int s)
Definition: Utility.cpp:158
FIX::ThreadedSocketInitiator::m_mutex
Mutex m_mutex
Definition: ThreadedSocketInitiator.h:79

## removeThread()

void FIX::ThreadedSocketInitiator::removeThread | ( | int | s | ) |

private

Definition at line 188 of file ThreadedSocketInitiator.cpp.

References m_mutex, m_threads, and FIX::thread_detach().

{
Locker l(m_mutex);
SocketToThread::iterator i = m_threads.find( s );
if ( i != m_threads.end() )
{
thread_detach( i->second );
m_threads.erase( i );
}
}
FIX::thread_detach
void thread_detach(thread_id thread)
Definition: Utility.cpp:425
FIX::ThreadedSocketInitiator::m_threads
SocketToThread m_threads
Definition: ThreadedSocketInitiator.h:78
FIX::ThreadedSocketInitiator::m_mutex
Mutex m_mutex
Definition: ThreadedSocketInitiator.h:79

## socketThread()

THREAD_PROC FIX::ThreadedSocketInitiator::socketThread | ( | void * | p | ) |

static private

Definition at line 200 of file ThreadedSocketInitiator.cpp.

References FIX::ThreadedSocketConnection::connect(), FIX::ThreadedSocketConnection::disconnect(), FIX::ThreadedSocketConnection::getSession(), FIX::Session::getSessionID(), FIX::ThreadedSocketConnection::getSocket(), FIX::Session::lookupSession(), FIX::Session::next(), and FIX::ThreadedSocketConnection::read().

Referenced by doConnect(), and lock().

{
ThreadPair * pair = reinterpret_cast < ThreadPair* > ( p );
ThreadedSocketInitiator* pInitiator = pair->first;
ThreadedSocketConnection* pConnection = pair->second;
FIX::SessionID sessionID = pConnection->getSession()->getSessionID();
FIX::Session* pSession = FIX::Session::lookupSession( sessionID );
int socket = pConnection->getSocket();
delete pair;
pInitiator->lock();
if( !pConnection->connect() )
{
pInitiator->getLog()->onEvent( "Connection failed" );
pConnection->disconnect();
delete pConnection;
pInitiator->removeThread( socket );
pInitiator->setDisconnected( sessionID );
return 0;
}
pInitiator->setConnected( sessionID );
pInitiator->getLog()->onEvent( "Connection succeeded" );
pSession->next();
while ( pConnection->read() ) {}
delete pConnection;
if( !pInitiator->isStopped() )
pInitiator->removeThread( socket );
pInitiator->setDisconnected( sessionID );
return 0;
}
FIX::Session::lookupSession
static Session * lookupSession(const SessionID &)
Definition: Session.cpp:1403
FIX::Session
Maintains the state and implements the logic of a FIX session.
Definition: Session.h:45
FIX::ThreadedSocketInitiator::ThreadPair
std::pair< ThreadedSocketInitiator *, ThreadedSocketConnection *> ThreadPair
Definition: ThreadedSocketInitiator.h:53
FIX::Session::next
void next()
Definition: Session.cpp:125
FIX::ThreadedSocketInitiator::ThreadedSocketInitiator
ThreadedSocketInitiator(Application &, MessageStoreFactory &, const SessionSettings &)
Definition: ThreadedSocketInitiator.cpp:32
FIX::SessionID
Unique session id consists of BeginString, SenderCompID and TargetCompID.
Definition: SessionID.h:30

## Member Data Documentation

## m_lastConnect

time_t FIX::ThreadedSocketInitiator::m_lastConnect

private

Definition at line 73 of file ThreadedSocketInitiator.h.

Referenced by onStart().

## m_mutex

Mutex FIX::ThreadedSocketInitiator::m_mutex

private

Definition at line 79 of file ThreadedSocketInitiator.h.

Referenced by addThread(), doConnect(), lock(), onStart(), onStop(), and removeThread().

## m_noDelay

bool FIX::ThreadedSocketInitiator::m_noDelay

private

Definition at line 75 of file ThreadedSocketInitiator.h.

Referenced by doConnect(), and onConfigure().

## m_rcvBufSize

int FIX::ThreadedSocketInitiator::m_rcvBufSize

private

Definition at line 77 of file ThreadedSocketInitiator.h.

Referenced by doConnect(), and onConfigure().

## m_reconnectInterval

int FIX::ThreadedSocketInitiator::m_reconnectInterval

private

Definition at line 74 of file ThreadedSocketInitiator.h.

Referenced by onConfigure(), and onStart().

## m_sendBufSize

int FIX::ThreadedSocketInitiator::m_sendBufSize

private

Definition at line 76 of file ThreadedSocketInitiator.h.

Referenced by doConnect(), and onConfigure().

## m_sessionToHostNum

SessionToHostNum FIX::ThreadedSocketInitiator::m_sessionToHostNum

private

Definition at line 72 of file ThreadedSocketInitiator.h.

Referenced by getHost().

## m_settings

SessionSettings FIX::ThreadedSocketInitiator::m_settings

private

Definition at line 71 of file ThreadedSocketInitiator.h.

## m_threads

SocketToThread FIX::ThreadedSocketInitiator::m_threads

private

Definition at line 78 of file ThreadedSocketInitiator.h.

Referenced by addThread(), onStop(), and removeThread().

The documentation for this class was generated from the following files:

- ThreadedSocketInitiator.h
- ThreadedSocketInitiator.cpp